<?php
require_once 'AsdZend/Form.php';

class Asd_Form_MetaboxAbstract extends AsdZend_Form
{
    protected $_postId;

    public function load()
    {
        $meta = Asd_Application::getModel('PostMeta')
            ->setPostId($this->_postId);

        foreach ($this->getElements() as $elem) {
            $elem->setValue($meta->getValue($elem->getName()));
        }

        return $this;
    }

    public function save()
    {
        $meta = Asd_Application::getModel('PostMeta')
            ->setPostId($this->_postId);

        foreach ($this->getElements() as $elem) {
            if (!$elem->getAttrib('disabled')) {
                $meta->setValue($elem->getName(), $elem->getValue());
            }
        }

        return $this;
    }

    //
    // Getters & setters
    //

    public function setPostId($value)
    {
        $this->_postId = $value;

        return $this;
    }

    public function getPostId()
    {
        return $this->_postId;
    }
}